var src = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
var map = {};
src.split("").forEach((s, i) => map[s] = i);
var encode62 = {
    src,
    map,
    time_delta: parseInt("zzzzz", 36),
    pack: 'efront-encode62s',
    packdecode(string) {
        if (!string) return string;
        return this.timedecode(string, this.pack);
    },
    packencode(string) {
        return this.timeencode(string, this.pack);
    },
    packupdate(string) {
        return this.timeupdate(string, this.pack);
    },
    geta(string) {
        string = String(string)
        string = string.length + string + "2017-08-19";
        var buff = src.split('');
        for (var cx = 0, dx = buff.length + src.length, sl = string.length, cl = buff.length; cx < dx; cx++) {
            var s1 = string.charCodeAt(cx % sl) % cl;
            var s2 = cx % cl;
            var btemp = buff[s1];
            buff[s1] = buff[s2];
            buff[s2] = btemp;
        }
        return buff.join('');
    },
    safeencode(string, sign, offset) {
        string = encodeURIComponent(string).replace(/\./g, '..').replace(/[\!'\(\)~]/g, a => escape(a)).replace(/%/g, '.');
        return this.encode(string, sign, offset);
    },
    safedecode(string, sign, offset) {
        string = this.encode(string, sign, offset).replace(/\.\.?/g, a => a === '.' ? "%" : ".");
        return decodeURIComponent(string);
    },
    timedecode(string, pack) {
        var { time_delta } = this;
        var time_rest = string.slice(string.length - time_delta.toString(36).length, string.length);
        var time_start = parseInt((new Date() - parseInt(time_rest, 36)) / time_delta) * time_delta;
        var time_stamp = time_start + parseInt(time_rest, 36);
        string = string.slice(0, string.length - time_delta.toString(36).length);
        if (pack) {
            string = this.decode62(string, time_stamp.toString(36) + pack);
            var sign = string.slice(string.length - 7, string.length);
            sign = parseInt(sign, 36);
            sign -= 0x600000000 + (time_stamp & 0xffffffff);
            string = string.slice(0, string.length - 7);
            string = decode62S(string);
            if (crc.string(time_stamp.toString(36) + pack + string) !== sign) throw new Error('数据校验不通过！');
            return string;
        }
        return this.safedecode(string, time_stamp.toString(36));
    },
    timeencode(string, pack) {
        var { time_delta } = this;
        var time_free = time_delta / 6 | 0;
        var time_stamp = +new Date() - time_free;
        var time_rest = time_stamp % time_delta;
        var time_rest_str = time_rest.toString(36);
        var time_delta_str = time_delta.toString(36);
        if (pack) {
            var sign = crc.string(time_stamp.toString(36) + pack + string);
            sign += 0x600000000 + (time_stamp & 0xffffffff);
            string = encode62S(string) + sign.toString(36);
            string = this.encode62(string, time_stamp.toString(36) + pack);
        }
        else {
            string = this.safeencode(string, time_stamp.toString(36));
        }
        return string + repeat("0", time_delta_str.length - time_rest_str.length) + time_rest_str;
    },
    timeupdate(string, pack) {
        var { time_delta } = this;
        var time_rest = string.slice(string.length - time_delta.toString(36).length, string.length);
        var time_start = parseInt((new Date() - parseInt(time_rest, 36)) / time_delta) * time_delta;
        var time_stamp = time_start + parseInt(time_rest, 36);
        if (time_stamp + (time_delta >> 1) > +new Date()) {
            return string;
        } else {
            return this.timeencode(this.timedecode(string, pack), pack);
        }
    },
    encode(data, sign, offset = 0) {
        if (!sign) return data;
        var result = String(data);
        sign = String(sign);
        var src = this.src;
        var result = result.replace(/\w/g, function (w, cx) {
            var code = map[w];
            if (!isNumber(code)) return w;
            var s = code ^ (sign.charCodeAt((offset + cx) % sign.length) % src.length);
            if (s >= src.length) return w;
            return src[s];
        });
        return result;
    }
};
encode62.decode62 = encode62.encode62 = encode62.encode;