assert(filterTime(''), ``);
assert(filterTime(null), '');
assert(filterTime(undefined), '');
assert(filterTime("我出生的第二年"), `我出生的第二年`);
assert(filterTime(+new Date + 86300000), '还有23小时58分钟');
assert(filterTime(+new Date + 110000), '还有1分钟');
assert(filterTime(+new Date + 120000), '还有2分钟');
assert(filterTime(+new Date + 60000), '还有1分钟');
assert(filterTime(+new Date + 59000), '59秒后');
assert(filterTime(+new Date + 58000), '58秒后');
assert(filterTime(+new Date + 8000), '8秒后');
assert(filterTime(+new Date + 1000), '1秒后');
assert(filterTime(+new Date), '刚刚');
assert(filterTime(+new Date), '刚刚');
assert(filterTime(+new Date - 59000), '刚刚');
assert(filterTime(new Date(2024, 3, 3), `y年M月d日 h:mm`), '2024年4月3日 0:00');
assert(filterTime(new Date(2024, 3, 3), `y年M月d日 h:mm`), '2024年4月3日 0:00');
assert(filterTime(new Date(2024, 3, 3, 19, 26, 2, 100), `y年M月d日 h:mm:ss.SSS`), '2024年4月3日 19:26:02.100');
assert(filterTime("2024年4月3号", `y年M月d日h:mm`), '2024年4月3日0:00');
assert(filterTime("2024年4月3号8点半", `y年M月d日h:mm`), '2024年4月3日8:30');
assert(filterTime("2024年4月3号9点三刻", `y年M月d日h:mm`), '2024年4月3日9:45');
assert(filterTime("2024年4月3号9点一刻", `y年M月d日h:mm`), '2024年4月3日9:15');
assert(filterTime("2024年4月3号下午3点一刻", `y年M月d日h:mm`), '2024年4月3日15:15');
assert(filterTime("2024年4月3号上午9点一刻", `y年M月d日h:mm`), '2024年4月3日9:15');
assert(filterTime("2024年4月3号晚上9点一刻", `y年M月d日h:mm`), '2024年4月3日21:15');
assert(filterTime("2024年4月3号傍晚6点一刻", `y年M月d日h:mm`), '2024年4月3日18:15');
assert(filterTime("2024年4月3号凌晨6点", `y年M月d日h:mm`), '2024年4月3日6:00');
assert(filterTime("2024年4月3号凌晨6点整", `y年M月d日h:mm`), '2024年4月3日6:00');
assert(filterTime("2024/4/3凌晨6点整", `y年M月d日h:mm`), '2024年4月3日6:00');
assert(filterTime("2024-4-3早上6点整", `y年M月d日h:mm`), '2024年4月3日6:00');
assert(filterTime("2024-4-3早上6点59分30秒20毫秒", `y年M月d日h:mm`), '2024年4月3日6:59');
assert(filterTime("2024-4-3早上6点59分30秒20毫秒", `y年M月d日h:mm:ss`), '2024年4月3日6:59:30');
assert(filterTime("2024-4-3早上6点59分30秒20毫秒", `y年M月d日h:mm:ss.S`), '2024年4月3日6:59:30.020');
